/***
 * Excerpted from "Stripes: and Java Web Development is Fun Again",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
***/
package stripesbook.action;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Date;
import java.util.List;
import java.util.Locale;
import net.sourceforge.stripes.action.DefaultHandler;
import net.sourceforge.stripes.action.ForwardResolution;
import net.sourceforge.stripes.action.Resolution;
import net.sourceforge.stripes.controller.StripesFilter;
import net.sourceforge.stripes.format.Formatter;
import net.sourceforge.stripes.format.FormatterFactory;
import net.sourceforge.stripes.validation.CreditCardTypeConverter;
import net.sourceforge.stripes.validation.PercentageTypeConverter;
import net.sourceforge.stripes.validation.OneToManyTypeConverter;
import net.sourceforge.stripes.validation.Validate;
import net.sourceforge.stripes.validation.ValidationState;
import stripesbook.opt.TimeTypeConverter;

public class DataTypesActionBean extends BaseActionBean {
    private static final String VIEW = "/WEB-INF/jsp/data_types.jsp";

    @SuppressWarnings("unchecked")
    @DefaultHandler
    public Resolution view() {
        FormatterFactory factory =
            StripesFilter.getConfiguration().getFormatterFactory();

        if (formatDouble != null) {
            Formatter doubleFormat = factory.getFormatter(
                Double.class, Locale.US, doubleFormatType, doubleFormatPattern);

            formattedDouble = doubleFormat.format(formatDouble);
        }
        if (formatDate != null) {
            System.out.println("formatDate: " + formatDate);
            System.out.println("formatType: " + dateFormatType);
            System.out.println("formatPattern: " + dateFormatPattern);

            Formatter dateFormat = factory.getFormatter(
                Date.class, Locale.US, dateFormatType, dateFormatPattern);

            formattedDate = dateFormat.format(formatDate);
            System.out.println("formattedDate: " + formattedDate);
        }
        return new ForwardResolution(VIEW);
    }

    private byte primitiveByte;

    public byte getPrimitiveByte() {
        return primitiveByte;
    }
    public void setPrimitiveByte(byte primitiveByte) {
        this.primitiveByte = primitiveByte;
    }

    private Byte wrapperByte;

    public Byte getWrapperByte() {
        return wrapperByte;
    }
    public void setWrapperByte(Byte wrapperByte) {
        this.wrapperByte = wrapperByte;
    }

    private short primitiveShort;

    public short getPrimitiveShort() {
        return primitiveShort;
    }
    public void setPrimitiveShort(short primitiveShort) {
        this.primitiveShort = primitiveShort;
    }

    private Short wrapperShort;

    public Short getWrapperShort() {
        return wrapperShort;
    }
    public void setWrapperShort(Short wrapperShort) {
        this.wrapperShort = wrapperShort;
    }

    private int primitiveInt;

    public int getPrimitiveInt() {
        return primitiveInt;
    }
    public void setPrimitiveInt(int primitiveInt) {
        this.primitiveInt = primitiveInt;
    }

    private Integer wrapperInteger;

    public Integer getWrapperInteger() {
        return wrapperInteger;
    }
    public void setWrapperInteger(Integer wrapperInteger) {
        this.wrapperInteger = wrapperInteger;
    }

    private long primitiveLong;

    public long getPrimitiveLong() {
        return primitiveLong;
    }
    public void setPrimitiveLong(long primitiveLong) {
        this.primitiveLong = primitiveLong;
    }

    private Long wrapperLong;

    public Long getWrapperLong() {
        return wrapperLong;
    }
    public void setWrapperLong(Long wrapperLong) {
        this.wrapperLong = wrapperLong;
    }

    private float primitiveFloat;

    public float getPrimitiveFloat() {
        return primitiveFloat;
    }
    public void setPrimitiveFloat(float primitiveFloat) {
        this.primitiveFloat = primitiveFloat;
    }

    private Float wrapperFloat;

    public Float getWrapperFloat() {
        return wrapperFloat;
    }
    public void setWrapperFloat(Float wrapperFloat) {
        this.wrapperFloat = wrapperFloat;
    }

    private double primitiveDouble;

    public double getPrimitiveDouble() {
        return primitiveDouble;
    }
    public void setPrimitiveDouble(double primitiveDouble) {
        this.primitiveDouble = primitiveDouble;
    }

    private Double wrapperDouble;

    public Double getWrapperDouble() {
        return wrapperDouble;
    }
    public void setWrapperDouble(Double wrapperDouble) {
        this.wrapperDouble = wrapperDouble;
    }

    private BigInteger bigInteger;

    public BigInteger getBigInteger() {
        return bigInteger;
    }
    public void setBigInteger(BigInteger bigInteger) {
        this.bigInteger = bigInteger;
    }

    private BigDecimal bigDecimal;

    public BigDecimal getBigDecimal() {
        return bigDecimal;
    }
    public void setBigDecimal(BigDecimal bigDecimal) {
        this.bigDecimal = bigDecimal;
    }

    private Date date;

    public Date getDate() {
        return date;
    }
    public void setDate(Date date) {
        this.date = date;
    }

    
    @Validate(converter=TimeTypeConverter.class)
    private Date time;
    

    public Date getTime() {
        return time;
    }
    public void setTime(Date time) {
        this.time = time;
    }

    private ValidationState validationState;

    public ValidationState getValidationState() {
        return validationState;
    }

    public void setValidationState(ValidationState validationState) {
        this.validationState = validationState;
    }

    private boolean primitiveBoolean;

    public boolean getPrimitiveBoolean() {
        return primitiveBoolean;
    }
    public void setPrimitiveBoolean(boolean primitiveBoolean) {
        this.primitiveBoolean = primitiveBoolean;
    }

    private Boolean wrapperBoolean;

    public Boolean getWrapperBoolean() {
        return wrapperBoolean;
    }
    public void setWrapperBoolean(Boolean wrapperBoolean) {
        this.wrapperBoolean = wrapperBoolean;
    }

    private char primitiveChar;

    public char getPrimitiveChar() {
        return primitiveChar;
    }
    public void setPrimitiveChar(char primitiveChar) {
        this.primitiveChar = primitiveChar;
    }

    private Character wrapperCharacter;

    public Character getWrapperCharacter() {
        return wrapperCharacter;
    }
    public void setWrapperCharacter(Character wrapperCharacter) {
        this.wrapperCharacter = wrapperCharacter;
    }

    @Validate(converter=PercentageTypeConverter.class)
    private float percentage;

    public float getPercentage() {
        return percentage;
    }
    public void setPercentage(float percentage) {
        this.percentage = percentage;
    }

    @Validate(converter=OneToManyTypeConverter.class)
    private List<Integer> oneToMany;

    public List<Integer> getOneToMany() {
        return oneToMany;
    }
    public void setOneToMany(List<Integer> oneToMany) {
        this.oneToMany = oneToMany;
    }

    @Validate(converter=OneToManyTypeConverter.class)
    private List oneToManyAnon;
    public List getOneToManyAnon() {
        return oneToManyAnon;
    }
    public void setOneToManyAnon(List oneToManyAnon) {
        this.oneToManyAnon = oneToManyAnon;
    }

    @Validate(converter=CreditCardTypeConverter.class)
    private String creditCardNumber;

    public String getCreditCardNumber() {
        return creditCardNumber;
    }
    public void setCreditCardNumber(String creditCardNumber) {
        this.creditCardNumber = creditCardNumber;
    }

    private Double formatDouble;

    public Double getFormatDouble() {
        return formatDouble;
    }
    public void setFormatDouble(Double formatDouble) {
        this.formatDouble = formatDouble;
    }

    private String doubleFormatType;

    public String getDoubleFormatType() {
        return doubleFormatType;
    }
    public void setDoubleFormatType(String doubleFormatType) {
        this.doubleFormatType = doubleFormatType;
    }

    private String doubleFormatPattern;

    public String getDoubleFormatPattern() {
        return doubleFormatPattern;
    }
    public void setDoubleFormatPattern(String doubleFormatPattern) {
        this.doubleFormatPattern = doubleFormatPattern;
    }

    private String formattedDouble;

    public String getFormattedDouble() {
        return formattedDouble;
    }

    private Date formatDate;

    public Date getFormatDate() {
        return formatDate;
    }
    public void setFormatDate(Date formatDate) {
        this.formatDate = formatDate;
    }

    private String dateFormatType;

    public String getDateFormatType() {
        return dateFormatType;
    }
    public void setDateFormatType(String dateFormatType) {
        this.dateFormatType = dateFormatType;
    }

    private String dateFormatPattern;

    public String getDateFormatPattern() {
        return dateFormatPattern;
    }
    public void setDateFormatPattern(String dateFormatPattern) {
        this.dateFormatPattern = dateFormatPattern;
    }

    private String formattedDate;

    public String getFormattedDate() {
        return formattedDate;
    }
}
